<?php
/**
 * Plugin Name: SmilePay_7-11 Ibon 
 * Plugin URI: http://www.smilepay.net
 * Description: SmilePay7-11 Ibon 
 * Author:  SmilePay
 * Author URI: http://www.smilepay.net
 * Version: 2.2.4
 */
add_action('plugins_loaded', 'SmilePayibon_gateway_init', 0);
function SmilePayibon_gateway_init() {
   if (!class_exists('WC_Payment_Gateway')) {
        return;
    }
    class WC_SmilePayibon extends WC_Payment_Gateway {
        public function __construct() {
            $this->id = 'SmilePayibon';
            $this->icon = apply_filters('woocommerce_SmilePayibon_icon', plugins_url('log/ibon_logo.jpg', __FILE__));
            $this->has_fields = false;
            $this->method_title = __('SmilePayibon', 'woocommerce');
            // Load the form fields.
            $this->init_form_fields();
            // Load the settings.
            $this->init_settings();
			
            // Define user set variables
            $this->title = $this->settings['title'];
            $this->description = $this->settings['description'];
            $this->dcvc = $this->settings['dcvc'];
			$this->Deadline_date = $this->settings['Deadline_date'];
			$this->Order_OKmain = $this->settings['Order_OKmain'];
			$this->reurl = $this->settings['reurl'];
			$this->Verify_key = $this->settings['Verify_key'];
			$this->Mid_smilepay = $this->settings['Mid_smilepay'];
            // Actions
            //add_action('init', array(&$this, 'check_SmilePayibon_response'));
            add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );
            add_action('woocommerce_thankyou_SmilePayibon', array($this, 'thankyou_page')); 
        }
        /**
         * Initialise Gateway Settings Form Fields
         *
         * @access public
         * @return void
         */
        public function init_form_fields() {  //x]m
			$urll=get_option('siteurl')."/?respond";
            $this->form_fields = array(
                'enabled' => array(
                    'title' => __(u2bi("ҥ/"), 'woocommerce'),
                    'type' => 'checkbox',
                    'label' => __(' SmilePay7-11 Ibon ', 'woocommerce'),
                    'default' => 'yes'
                ),
                'title' => array(
                    'title' => __(u2bi('D'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bi('UȦbbɩܪIڤ覡D'), 'woocommerce'),
                    'default' => __(u2bi('SmilePay7-11 Ibon úO'), 'woocommerce')
                ),
                'description' => array(
                    'title' => __(u2bi('ȤT'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2bi('UȦbܥIڤ覡ɩܪФr'), 'woocommerce'),
                    'default' => __(u2bi("SmilePay 7-11 Ibon úO"), 'woocommerce')
                ),
                'dcvc' => array(
                    'title' => __(u2bi('өN'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bi('жJzSmilePayөN'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
                'Verify_key' => array(
                    'title' => __(u2bi('ӮaˬdX'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bi('жJzSmilePayӮaˬdXAˬdXӮaxuIAPIvAнƻsöKJW'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
                'Mid_smilepay' => array(
                    'title' => __(u2bi('ҽX'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bi('жJzSmilePaҽXAҽXӮaxu򥻸ƺ޲zvAнƻsöKJWApҽЫOdť'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),				
				'Deadline_date' => array(
                    'title' => __(u2bi('úںI'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bi('жJúںIAojCApLƮɩγ]w~N۰ʥHCѬw]'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
				'Order_OKmain' => array(
                    'title' => __(u2bi('U榨\ܰT'), 'woocommerce'),
                    'type' => 'textarea',
                    'description' => __(u2bi('U榨\ܰT'), 'woocommerce'),
                    'default' => __('', 'woocommerce')
                ),
				'reurl' => array(
                    'title' => __(u2bi('^em'), 'woocommerce'),
                    'type' => 'text',
                    'description' => __(u2bi('^emAбNUCrƻsWؤ(p^eЯdť)</br><font color=red ue size=+1>'.$urll.'</font>', 'woocommerce')),
                    'default' => __('', 'woocommerce')
                )
            );
        }
        /**
         * Admin Panel Options
         * - Options for bits like 'title' and availability on a country-by-country basis
         *
         * @access public
         * @return void
         */
       public function get_SmilePayibon_args($order) {
            global $woocommerce;

            $paymethod = 'ibon';
            $order_id = $order->id;
			$post_status = $order->post_status;

            $SmilePayibon_args = array(
                "dcvc" => $this->dcvc,
                "payment_type" => $paymethod,
                "od_sob" => $order_id,
				"post_status" => $post_status,
                'reurl' => $this->reurl,
                'Verify_key' => $this->Verify_key,
                'Mid_smilepay' => $this->Mid_smilepay,
				'Deadline_date' => $this->Deadline_date,
				'Order_OKmain' => $this->Order_OKmain,
				"amt" => round($order->get_order_total()),
            );
            $SmilePayibon_args = apply_filters('woocommerce_SmilePayibon_args', $SmilePayibon_args);
            return $SmilePayibon_args;
        }
		
       public function thankyou_page($order_id) {  //^ǰѼ  P  7-11 Ibon
			global $post, $wpdb, $thepostid, $theorder, $order_status, $woocommerce;
			$order = &new WC_Order($order_id);

			$SmilePayibon_args = $this->get_SmilePayibon_args($order);
			$order_status=$SmilePayibon_args['post_status'];

			
		if($order_status=='wc-pending')
		{
	
			if(is_numeric($SmilePayibon_args['Deadline_date'])&&$SmilePayibon_args['Deadline_date']<6)
			{$Deadline_date_value=$SmilePayibon_args['Deadline_date'];}
			else
			{$Deadline_date_value=6;}
			$Deadline_date = date("Y/m/d",mktime(0,0,0,date("m"),date("d")+$Deadline_date_value,date("Y")));			
          	//
		  	$smilepay_gateway = 'https://ssl.smse.com.tw/api/sppayment.asp';
			if($SmilePayibon_args['reurl']!=''){$Vk=$SmilePayibon_args['reurl']."=".$order->order_key;}else{$Vk='';}
			$post_str = 'Dcvc=' . $SmilePayibon_args['dcvc'] .
					'&Pay_zg=4' .
					'&Rvg2c=1' .
					'&Pur_name=' .$order->billing_first_name.$order->billing_last_name.
					'&Tel_number=' .$order->billing_phone.
					'&Address=' .$order->billing_address_1.
					'&Email=' .$order->billing_email.
					'&Data_id=' . $SmilePayibon_args['od_sob'].
					'&od_sob=' . $SmilePayibon_args['od_sob'].
					'&Amount=' . $SmilePayibon_args['amt'].
					'&Deadline_date=' . $Deadline_date.
					'&Roturl_status=' . 'woook'.
					'&Roturl=' . $Vk.
					'&Verify_key=' . $SmilePayibon_args['Verify_key'].
					'&Remark=woocommerce';
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $smilepay_gateway);
			curl_setopt($ch, CURLOPT_VERBOSE, 1);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $post_str);
			$string = curl_exec($ch);
			curl_close($ch);
			
			//gJƵ
			$xml = simplexml_load_string($string);
			$Status = $xml->Status;
			if(strpos($string,"<SmilePay>")&&$Status=="1")
			{
				//gJqúO-O
				$ordertext="úO覡G<font color=red>ibon</font><br>úONXG<font color=red>".$xml->IbonNo."</font><br>úOG<font color=red>".$xml->PayEndDate."</font></br>pWLúOФúO</br>";
				$order->add_order_note(u2bi($ordertext),"1");
				$ordertext="ФŧRTG".$xml->SmilePayNO;
				$order->add_order_note(u2bi($ordertext),"0");
				//קq檬A	
				$order->update_status( 'on-hold' );	
				//ܤe
				echo u2bi("<font color='red' size='3'>`NGqwߡA|IڡAШúڸƺɳtI</font>");
				$showtext= "<br><br>úO覡G<font color='red' size='3'>ibon</font></td></tr>";
				$showtext=$showtext."<br>úONXG<font color='red' size='3'>".$xml->IbonNo."</font>";
				$showtext=$showtext."<br>úOG<font color='red' size='3'>".$xml->PayEndDate."</font>";
				echo u2bi($showtext);
				echo u2bi("<br><font color='red' size='3'>pѰO<u>úOT</u>ЦۤWC<u>b]w->q->˵</u></font>");
				echo "<br><br>".$SmilePayibon_args['Order_OKmain'];
				
			}
			else
			{
				if($Status!="")
				{	$ordererror="</br>~NXG".$xml->Status."</br>e]G".$xml->Desc."</br>OɶG".date("Y-m-d H:i:s",mktime(date(H)+8));	}
				else
				{	$ordererror="</br>e]Gsu`</br>OɶG".date("Y-m-d H:i:s",mktime(date(H)+8));	}
				$order->add_order_note(u2bi($ordererror),"1");
				$order->update_status( 'cancelled' );				
			}
		}
		else
		{
			echo u2bi("<font color='red' size='3'>pѰO<u>úOT</u>ЦۤWC<u>b]w->q->˵</u></font>");
		}			


}
        /**
         * Process the payment and return the result
         *
         * @access public
         * @param int $order_id
         * @return array
         */
        public function process_payment($order_id) {
		$order = new WC_Order( $order_id );

		// Mark as on-hold (we're awaiting the cheque)
		// Reduce stock levels
		$order->reduce_order_stock();
		// Remove cart
		WC()->cart->empty_cart();

		// Return thankyou redirect
		return array(
			'result' 	=> 'success',
			'redirect'	=> $this->get_return_url( $order )
		);
        }

        /**
         * Payment form on checkout page
         *
         * @access public
         * @return void
         */

    }
    /**
     * Add the gateway to WooCommerce
     *
     * @access public
     * @param array $methods
     * @package		WooCommerce/Classes/Payment
     * @return array
     */
    function add_SmilePayibon_gateway($methods) {
        $methods[] = 'WC_SmilePayibon';
        return $methods;
    }

    add_filter('woocommerce_payment_gateways', 'add_SmilePayibon_gateway');
}
function u2bi($text)//eX
{	return iconv("big5","UTF-8",$text);}
function b2ui($text)//gJƮw
{	return iconv("UTF-8","big5",$text);}
?>